<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
namespace app\components;
use Yii;
use yii\base\Component;
use app\models\Menus;
use app\models\PerfilMenus;

class Administracao extends Component{
     
    private static $acaoCria;
    //::::::::: DESENHA OS MENUS DE ACORDO COM PERFIL DO UTILIZADOR ::::::::://
    public function DesenharPerfilMenuComponent()
    {
        $menu_html = ''; 
        $menus_pai = Menus::find()->orderBy(['ORDEM'=>'asc'])->where(['FLAG_ACAO'=>NULL,'SELF_ID'=>NULL,'ESTADO'=>'A'])->all(); 
        foreach($menus_pai as $menu){
            //QUANDO O PERFIL TEM ACESSO AOS MENUS
            if($this->verificaPermissao($menu->ID) === true)
            {
                $class_menu_ativo = '';
                $class_open_submenu = '';
                $menu_pai_clicado = '';
                $menu_filho_clicado = '';
                if (isset(Yii::$app->session['id_op'])) {
                    $menu_activo = Menus::find()->where(['ID' => Yii::$app->session['id_op'], 'ESTADO' => 'A'])->one();
                    $menu_pai_clicado = isset($menu_activo->sELF) ? $menu_activo->sELF->ID : $menu_activo->ID;
                    $menu_filho_clicado = isset($menu_activo->sELF) ? Yii::$app->session['id_op'] : '';
                }
                if ($menu_pai_clicado == $menu->ID) {
                    $class_menu_ativo = 'active';
                    $class_open_submenu = 'show';
                }

                $filhos_menu = $this->desenhaSubMenu($menu->ID, $class_open_submenu, $menu_filho_clicado); 
                //QUANDO O MENU EXPECIFICO TEM SUBMENUS
                if($filhos_menu !== false)
                {	
                    $icon_right = 'caret';
                    $menu_html .= '
                    <ul class="nav">
                        <li class="nav-item '.$class_menu_ativo.'">
                            <a class="nav-link" data-toggle="collapse" href="#'.$menu->ID.'">
                                <i class="material-icons">'.$menu->URL_ICON.'</i>
                                <p> '.mb_strtoupper($menu->DS_MENU, "UTF-8").'
                                    <b class="'.$icon_right.'"></b>
                                </p>
                            </a>';
                        $menu_html .= $filhos_menu.'</li>';
                }
                //QUANDO O MENU EXPECIFICO NÃO TEM SUBMENUS
                else{
                    $icon_right = '';
                    $menu_html .= '
                        <li class="nav-item '.$class_menu_ativo.'">
                            <a class="nav-link" href="index.php?r='.$menu->URL.'">
                                <i class="material-icons"> '.$menu->URL_ICON.' </i>
                                <p> '.mb_strtoupper($menu->DS_MENU, "UTF-8").' 
                                    <b class="'.$icon_right.'"></b>
                                </p>
                            </a>
                        </li>
                    </ul>';
                } 
            }  
        } 
        return $menu_html; 
    } 
    
    public function verificaPermissao($id_menu)
    {
        $perfil_id = Yii::$app->user->identity->PERFIL_ID; 
        $profilesmenus = PerfilMenus::find()->where(['ESTADO'=>'A','PERFIL_ID'=>$perfil_id, 'MENUS_ID'=>$id_menu])->one(); 
        if($profilesmenus !== null)
        {
            return true;
        }else{
            return false;    
        } 

    }
    
    public function desenhaSubMenu($id_menu_pai, $class_open_submenu, $menu_filho_clicado)
    {
        $menu_html = '<div class="collapse '.$class_open_submenu.'" id="'.$id_menu_pai.'">
                        <ul class="nav">';
        //VERIFICAR SE MENU PAI TEM FILHOS "SUBMENU"
        $sub_menus = Menus::find()->orderBy(['ORDEM'=>'asc'])->where(['FLAG_ACAO'=>NULL,'SELF_ID'=>$id_menu_pai,'ESTADO'=>'A'])->all(); 
        if($sub_menus != NULL)
        {
            foreach($sub_menus as $menu){
                //QUANDO O PERFIL TEM ACESSO AOS MENUS
                if($this->verificaPermissao($menu->ID) === true)
                {
                    $class_submenu_ativo = '';
                    if ($menu_filho_clicado == $menu->ID) {
                        $class_submenu_ativo = 'active';
                    }

                    $filhos_menu = $this->desenhaSubMenu($menu->ID, $class_open_submenu, $class_submenu_ativo); 
                    if($filhos_menu !== false)
                    {	
                        $menu_html .= '
                            <li class="nav-item '.$class_submenu_ativo.'">
                                <a class="nav-link" href="index.php?r='. $menu->URL.'">
                                    <span class="sidebar-mini"> '.mb_substr($menu->DS_MENU, 0, 1, "UTF-8").' </span>
                                    <span class="sidebar-normal"> '.$menu->DS_MENU.' </span>
                                </a>';
                                $menu_html .= $filhos_menu .
                            '</li>';
                    }else{
                        $menu_html .= '
                        <li class="nav-item '.$class_submenu_ativo.'">
                            <a class="nav-link" href="index.php?r='. $menu->URL.'&id_opracao='.$menu->ID.'">
                                <span class="sidebar-mini"> '.mb_substr($menu->DS_MENU, 0, 1, "UTF-8").' </span>
                                <span class="sidebar-normal"> '.$menu->DS_MENU.' </span>
                            </a>
                        </li>';
                    }
                }
            }
            $menu_html .= '</ul>
                    </div>'; 
            return $menu_html;
        }else{
            return false;  
        }
    } 
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::://
    
    //::::: DESENHA OS PERFIS COM OS MENUS P/ ATRIBUIÇÃO DAS PERMISSOES :::://
    public function DesenharPerfilMenuTree($perfil_id)
    { 
        $result = Menus::find()->where(['ESTADO' => 'A', 'SELF_ID' => NULL])->orderby('ORDEM')->all();
        $tree = '';
        if(count($result)){
            $tree .= '<ul id="perfilTreeList" class="mainUL" style="list-style: none;padding-left:13px; padding-top: 10px">';
            foreach($result as $rowRoot){
                //::::check if level 2 exist:::::::  
                $resultChild = Menus::find()->where(['ESTADO' => 'A','SELF_ID' => $rowRoot->ID])->all();
                $checkR = $this->chekPerfilMenuExiste($perfil_id, $rowRoot->ID);
                if(count($resultChild)){
                    $visivel = ':visible';
                    $child = 'onchange="js:updateChilds(this)"';
                }else{
                    $visivel = ':hidden';
                    $child = '';
                }
                $iconTreeListSub = '<span style="cursor:pointer; visibility' . $visivel . '" id="btnColapse" class="treelistSub collapsed" data-toggle="collapse" data-target="#' . $rowRoot['ID'] . '"></span>';
                $tree .='' . $iconTreeListSub . '<li><a><input id="checkBoxFildRoot" '.$child.' name="allChkElement" type="checkbox" ' . $checkR . ' value="' . $rowRoot['ID'] . '" ><label>' . $rowRoot['DS_MENU'] . '</label>';
                if(count($resultChild)){
                    $tree .= '<div id="' . $rowRoot['ID'] . '" class="collapse">';
                    $tree .='<ul style="list-style: none">';
                    foreach ($resultChild as $rowChild){
                        //::::check if level 3 exist::::::: 
                        $resultNephew = Menus::find()->where(['ESTADO' => 'A', 'FLAG_ACAO' => 'sim', 'SELF_ID' => $rowChild->ID])->all();
                        $checkC = $this->chekPerfilMenuExiste($perfil_id, $rowChild['ID']);
                        if(count($resultNephew)){
                            $visivel = ':visible';
                            $child = 'onchange="js:updateChilds(this);updateParent(this)"';
                        }else{
                            $visivel = ':hidden';
                            $child = 'onchange="js:updateChilds(this);updateParent(this)"';
                        }
                        $iconTreeListSub2 = '<span style="cursor:pointer; visibility' . $visivel . '" id="btnColapse" class="treelistSub collapsed" data-toggle="collapse" data-target="#' . $rowChild['ID'] . '"></span>';
                        $tree .='' . $iconTreeListSub2 . '<li><a><input name="allChkElement" '.$child.' type="checkbox" ' . $checkC . ' value="' . $rowChild['ID'] . '" ><label>' . $rowChild['DS_MENU'] . '</label>';
                        if(count($resultNephew)){
                            $tree .= '<div id="' . $rowChild['ID'] . '" class="collapse">';
                            $tree .='<ul style="list-style: disc">'; //DESENHAR ACOES PARA OS MENUS
                            foreach($resultNephew as $rowNephew){
                                $checkN = $this->chekPerfilMenuExiste($perfil_id, $rowNephew['ID']);
                                $tree .='<li><a ><input name="allChkElement" onchange="js:updateParent(this)" type="checkbox" ' . $checkN . ' value="' . $rowNephew['ID'] . '" ><label>' . $rowNephew['DS_MENU'] . '</label></a></li>';
                            }
                            $tree .='</ul><div>';
                        }
                        $tree .='</a></li>';
                    }
                    $tree .='</ul></div>';
                }
                $tree .='</a></li>';
            }
            $tree .='</ul>'; 
        }else{
            $tree = 'Não existem menus!';
        }
        return $tree;
    } 
    
    public function chekPerfilMenuExiste($id_perfil, $id_menu){
        $resultChild = PerfilMenus::find()->where(['ESTADO' => 'A', 'PERFIL_ID' => $id_perfil, 'MENUS_ID' => $id_menu])->all();
        if($resultChild){
            return  "checked";
        } else {
            return "";
        } 
    }
    
    public function CriarEliminarPermisao($acao,$perfil_id,$menu_id){
        if($acao == 'criar'){
            $modelExist = PerfilMenus::find()->where(['ESTADO'=>'A','PERFIL_ID'=>$perfil_id,'MENUS_ID'=>$menu_id])->one(); 
            if(!$modelExist){
                $model = new PerfilMenus();
                $model->ESTADO = "A";
                $model->ID = \Faker\Provider\Uuid::uuid(); 
                $model->PERFIL_ID = $perfil_id;
                $model->MENUS_ID = $menu_id;
                $model->DT_REGISTO = date('Y-m-d H:i:s');
                return $model->save();
            }
        }if($acao == 'eliminar'){
            $model = PerfilMenus::find()->where(['ESTADO'=>'A','PERFIL_ID'=>$perfil_id,'MENUS_ID'=>$menu_id])->one(); 
            return $model->delete();
        }
    }
    //::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::://
   
    //::::: FILTRAR TODO URL PARA BLOQUEAR ACOES SEM PERMISSOES :::://
    function hasPermission($action){ 
        //PEGA TODOS URLs REQUESITADOS (*1)
        $request_parsed = \Yii::$app->urlManager->parseRequest(\Yii::$app->request); 
        if(isset($request_parsed[0]) && $action == NULL){
            $url = explode("/", $request_parsed[0]);
            $controller = $url[0];
            if(sizeof($url) == 1){
                $action = 'index';
            }else{
                $action = $url[1];
            } 
        }   
        //verifica se tem permissao ao menu pricipal (*2)
        $menu_id_pai = Menus::find()->where(['ESTADO'=>'A','URL' => $controller])->one();  
		
        if(isset($menu_id_pai->sELF)){
            $has_menu_principal = PerfilMenus::find()
            ->where(['ESTADO'=>'A','MENUS_ID' => $menu_id_pai->sELF->ID, 'PERFIL_ID' => \Yii::$app->user->identity->PERFIL_ID])->one();			
            if(!$has_menu_principal){
                return false;
            }
        }
        // CASO TER ACESSO AO (*2)
        //verificar se tem permissao para aceder o controlador caso tenha, logo tera acesso ao acao index por default
        if($menu_id_pai){
            $has_sub_menu = PerfilMenus::find()
            ->where(['ESTADO'=>'A','MENUS_ID' => $menu_id_pai->ID, 'PERFIL_ID' => \Yii::$app->user->identity->PERFIL_ID])->one();
            if(!$has_sub_menu){
                return false;
            }
        }
		
        //DAR PERMISSOES PARA AÇÃO INDEX DE TODOS CONTROLADORES
        if($action == 'index' ){
            return TRUE;
        }
        //verifica permissoe para os acoes do controlador (create, delete, update, view) 
        $menu_id_acoes = Menus::find()->where(['ESTADO'=>'A','SELF_ID' => $menu_id_pai->ID, 'URL' => $action])->one();  
        if($menu_id_acoes){
            $has_permission = PerfilMenus::find()
                ->where(['ESTADO'=>'A','MENUS_ID' => $menu_id_acoes->ID, 'PERFIL_ID' => \Yii::$app->user->identity->PERFIL_ID])->one();
            if($has_permission){
                return TRUE;
            }else{
                return FALSE;  
            }
        }else{	
            return False;   
        } 
    }
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::://
    

    //:::::CAREGA TODAS AS AÇÕES DOS MENUS PARA PERFILS DO UTILIZADOR
    public static function getAtionMenu($operacao){
        $acaoPermitidas = '';  
        $menus_root = Menus::find()->where(['ESTADO'=>'A','ID'=>$operacao])->one();
            $menus_acoes = Menus::find()->orderBy('ORDEM')->where(['ESTADO'=>'A','SELF_ID'=>$menus_root->ID,'FLAG_ACAO'=>'sim'])->all();
            foreach ($menus_acoes as $child){ 
                if (self::verifica_perm($child->ID)){
                    if($child->DS_MENU == 'Ver'){
                        $acaoPermitidas .= '{view}';
                    }if($child->DS_MENU == 'Eliminar'){
                        $acaoPermitidas .= '{delete}';
                    }if($child->DS_MENU == 'Editar'){
                        $acaoPermitidas .= '{update}';
                    }if($child->DS_MENU == 'Criar-Acao'){
                        $acaoPermitidas .= '{create-acao}';
                    }if($child->DS_MENU == 'Ver-Acao'){
                        $acaoPermitidas .= '{view-acao}';
                    }if($child->DS_MENU == 'Editar-Acao'){
                        $acaoPermitidas .= '{update-acao}';
                    }if($child->DS_MENU == 'Eliminar-Acao'){
                        $acaoPermitidas .= '{delete-acao}';
                    }if($child->DS_MENU == 'Criar'){ 
                        self::setAcaoCria(true);
                    }
                } 
            } 
        return $acaoPermitidas;
    }

    static function getAcaoCria(){
        return self::$acaoCria;
    } 

    static function setAcaoCria($acaoCria){
        self::$acaoCria = $acaoCria;
    } 
    
    public static function verifica_perm($id_menu){
        $perfil_id = Yii::$app->user->identity->PERFIL_ID;  
        $menus  = PerfilMenus::find()->where(['ESTADO'=>'A','PERFIL_ID'=>$perfil_id, 'MENUS_ID'=>$id_menu])->one();
        if($menus != null){
            return true;
        }else{
           return false;
        } 
    }
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::://

    //:: CARREGAR OS MENUS DE ACORDO COM MENU PRINCIPAL PARA CRIACAO DE ACOES :://
    public function desenharMenus($id){
        $menus = Menus::find()->where(['ESTADO'=>'A','SELF_ID' => $id])->orderby('ORDEM')->all();
        if ($menus){
            echo '<option value="">--- Menu ---</option>';
            foreach ($menus as $menus){
                echo "<option value='" . $menus->ID . "'>" . $menus->DS_MENU . "</option>";
            }
        }else{
            echo '<option value="">--- Menu ---</option>';
        }
    }
    //:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::://
}
 
