<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "menus".
 *
 * @property string $ID
 * @property string $SELF_ID
 * @property integer $ORDEM
 * @property string $DS_MENU
 * @property string $URL
 * @property string $URL_ICON
 * @property string $FLAG_ACAO
 * @property string $ESTADO
 *
 * @property Acao $sELF
 * @property Acao[] $acaos
 * @property PerfilMenus[] $perfilMenuses
 */
class Acao extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'menus';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['ID', 'DS_MENU', 'ESTADO'], 'required'],
            [['ORDEM'], 'integer'],
            [['ID', 'SELF_ID'], 'string', 'max' => 36],
            [['DS_MENU', 'URL'], 'string', 'max' => 1024],
            [['URL_ICON'], 'string', 'max' => 100],
            [['FLAG_ACAO'], 'string', 'max' => 5],
            [['ESTADO'], 'string', 'max' => 1],
            [['SELF_ID'], 'exist', 'skipOnError' => true, 'targetClass' => Menus::className(), 'targetAttribute' => ['SELF_ID' => 'ID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'SELF_ID' => 'Menu Principal',
            'ORDEM' => 'Ordem',
            'DS_MENU' => 'Ação',
            'URL' => 'Url',
            'URL_ICON' => 'Url Icon',
            'FLAG_ACAO' => 'Flag  Acao',
            'ESTADO' => 'Estado',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getSELF()
    {
        return $this->hasOne(Acao::className(), ['ID' => 'SELF_ID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getAcao()
    {
        return $this->hasMany(Acao::className(), ['SELF_ID' => 'ID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPerfilMenuses()
    {
        return $this->hasMany(PerfilMenus::className(), ['MENUS_ID' => 'ID']);
    }
}
