<?php

namespace app\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Acao;

/**
 * MenusSearch represents the model behind the search form about `app\models\Acao`.
 */
class AcaoSearch extends Acao
{
    public $globalSearch;
    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['ID', 'SELF_ID', 'DS_MENU', 'URL', 'globalSearch', 'URL_ICON', 'FLAG_ACAO', 'ESTADO'], 'safe'],
            [['ORDEM'], 'integer'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Acao::find()->orderBy('SELF_ID');

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'ORDEM' => $this->ORDEM,
        ]);

        $query->orFilterWhere(['like', 'ID', $this->globalSearch])
            ->orFilterWhere(['like', 'SELF_ID', $this->globalSearch])
            ->orFilterWhere(['like', 'DS_MENU', $this->globalSearch])
            ->orFilterWhere(['like', 'URL', $this->globalSearch])
            ->orFilterWhere(['like', 'URL_ICON', $this->globalSearch])
            ->andFilterWhere(['like', 'FLAG_ACAO', 'sim'])
            ->andFilterWhere(['like', 'ESTADO', 'A']);

        return $dataProvider;
    }
}
