<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Delegados;

/**
 * DelegadosSearch represents the model behind the search form of `app\models\Delegados`.
 */
class DelegadosSearch extends Delegados
{

    public $globalSearch;    
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'titulo', 'descricao', 'globalSearch', 'estado'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Delegados::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->orFilterWhere(['like', 'id', $this->globalSearch])
            ->orFilterWhere(['like', 'titulo', $this->globalSearch])
            ->orFilterWhere(['like', 'descricao', $this->globalSearch])
             ->andFilterWhere(['like', 'ESTADO', '7']);
            //->orFilterWhere(['like', 'estado', $this->estado]);

        return $dataProvider;
    }
}
