<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "eventos_local".
 *
 * @property string $id
 * @property string $evento
 * @property string $local
 * @property string $data
 * @property int $estado
 * @property string $data_regist
 * @property string $descriacao
 */
class EventosLocal extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'eventos_local';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'evento', 'local', 'data', 'estado', 'descriacao'], 'required'],
            [['estado'], 'integer'],
            [['data_regist'], 'safe'],
            [['descriacao'], 'string'],
            [['id'], 'string', 'max' => 36],
            [['evento'], 'string', 'max' => 200],
            [['local'], 'string', 'max' => 150],
            [['data'], 'string', 'max' => 20],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'evento' => 'Evento',
            'local' => 'Local',
            'data' => 'Data',
            'estado' => 'Estado',
            'data_regist' => 'Data Regist',
            'descriacao' => 'Descriacao',
        ];
    }
}
