<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "perfil".
 *
 * @property string $ID
 * @property string $NOME
 * @property string $DESCR
 * @property string $ESTADO
 *
 * @property PerfilMenus[] $perfilMenuses
 * @property User[] $users
 */
class Perfil extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'perfil';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['ID', 'NOME', 'ESTADO'], 'required'],
            [['ID'], 'string', 'max' => 36],
            [['NOME'], 'string', 'max' => 75],
            [['DESCR'], 'string', 'max' => 500],
            [['ESTADO'], 'string', 'max' => 1],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'NOME' => 'Nome',
            'DESCR' => 'Descrição',
            'ESTADO' => 'Estado',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPerfilMenuses()
    {
        return $this->hasMany(PerfilMenus::className(), ['PERFIL_ID' => 'ID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getUsers()
    {
        return $this->hasMany(User::className(), ['PERFIL_ID' => 'ID']);
    }
}
