<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "perfil_menus".
 *
 * @property string $ID
 * @property string $PERFIL_ID
 * @property string $MENUS_ID
 * @property string $DT_REGISTO
 * @property string $ESTADO
 *
 * @property Menus $mENUS
 * @property Perfil $pERFIL
 */
class PerfilMenus extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'perfil_menus';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['ID', 'PERFIL_ID', 'MENUS_ID', 'DT_REGISTO', 'ESTADO'], 'required'],
            [['DT_REGISTO'], 'safe'],
            [['ID', 'PERFIL_ID', 'MENUS_ID'], 'string', 'max' => 36],
            [['ESTADO'], 'string', 'max' => 1],
            [['MENUS_ID'], 'exist', 'skipOnError' => true, 'targetClass' => Menus::className(), 'targetAttribute' => ['MENUS_ID' => 'ID']],
            [['PERFIL_ID'], 'exist', 'skipOnError' => true, 'targetClass' => Perfil::className(), 'targetAttribute' => ['PERFIL_ID' => 'ID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'PERFIL_ID' => 'Perfil  ID',
            'MENUS_ID' => 'Menus  ID',
            'DT_REGISTO' => 'Dt  Registo',
            'ESTADO' => 'Estado',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getMENUS()
    {
        return $this->hasOne(Menus::className(), ['ID' => 'MENUS_ID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPERFIL()
    {
        return $this->hasOne(Perfil::className(), ['ID' => 'PERFIL_ID']);
    }
}
