<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "tiket_registros".
 *
 * @property string $id
 * @property string $qrcod
 * @property string $nome
 * @property string $apelido
 * @property string $pais
 * @property string $respondido
 * @property string $solicta_destino
 * @property string $local_partida
 * @property string $local_chegada
 * @property string $numero_doc
 * @property string $propal
 * @property string $categoria
 * @property int $local
 * @property string $token
 * @property int $estado
 * @property string $data_registo
 */
class TiketRegistros extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'tiket_registros';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'qrcod', 'nome', 'apelido', 'pais', 'respondido', 'solicta_destino', 'local_partida', 'local_chegada', 'numero_doc', 'propal', 'categoria', 'local', 'token', 'estado', 'data_registo'], 'required'],
            [['local', 'estado'], 'integer'],
            [['data_registo'], 'safe'],
            [['id', 'numero_doc'], 'string', 'max' => 36],
            [['qrcod'], 'string', 'max' => 150],
            [['nome', 'local_partida', 'local_chegada'], 'string', 'max' => 50],
            [['apelido', 'solicta_destino'], 'string', 'max' => 150],
            [['pais', 'categoria'], 'string', 'max' => 100],
            [['respondido', 'propal'], 'string', 'max' => 10],
            [['token'], 'string', 'max' => 255],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'qrcod' => 'Qrcod',
            'nome' => 'Nome',
            'apelido' => 'Apelido',
            'pais' => 'Pais',
            'respondido' => 'Respondido',
            'solicta_destino' => 'Empresa',
            'local_partida' => 'Local Partida',
            'local_chegada' => 'Local Chegada',
            'numero_doc' => 'Numero Doc',
            'propal' => 'Propal',
            'categoria' => 'Categoria',
            'local' => 'Local',
            'token' => 'Token',
            'estado' => 'Estado',
            'data_registo' => 'Data Registo',
        ];
    }
}
