<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\TiketRegistros;

/**
 * TiketRegistrosSearch represents the model behind the search form of `app\models\TiketRegistros`.
 */
class TiketRegistrosSearch extends TiketRegistros
{
    /**
     * {@inheritdoc}
     */
     public $globalSearch;    

    public function rules()
    {
        return [
            [['id', 'qrcod', 'nome', 'apelido', 'pais', 'respondido', 'solicta_destino', 'local_partida', 'local_chegada', 'numero_doc', 'propal', 'categoria', 'token', 'data_registo', 'globalSearch'], 'safe'],
            [['local', 'estado'], 'integer'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = TiketRegistros::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        /*$query->orFilterWhere([
            'local' => $this->local,
            'estado' => $this->estado,
            'data_registo' => $this->data_registo,
        ]);*/

        $query->orFilterWhere(['like', 'id', $this->globalSearch])
            ->orFilterWhere(['like', 'qrcod', $this->globalSearch])
            ->orFilterWhere(['like', 'nome', $this->globalSearch])
            ->orFilterWhere(['like', 'apelido', $this->globalSearch])
            ->orFilterWhere(['like', 'pais', $this->globalSearch])
            ->orFilterWhere(['like', 'respondido', $this->globalSearch])
            ->orFilterWhere(['like', 'solicta_destino', $this->globalSearch])
            ->orFilterWhere(['like', 'local_partida', $this->globalSearch])
            ->orFilterWhere(['like', 'local_chegada', $this->globalSearch])
            ->orFilterWhere(['like', 'numero_doc', $this->globalSearch])
            ->orFilterWhere(['like', 'propal', $this->globalSearch])
            ->orFilterWhere(['like', 'categoria', $this->globalSearch])
            ->orFilterWhere(['like', 'token', $this->globalSearch])
            ->andFilterWhere(['like', 'estado', "7"]);

        return $dataProvider;
    }
}
