<?php

namespace app\models;
use yii\web\IdentityInterface;

use Yii;

/**
 * This is the model class for table "user".
 *
 * @property string $ID
 * @property string $PERFIL_ID
 * @property string $FUNCIONARIO_ID
 * @property string $USERNAME
 * @property string $LOGIN
 * @property string $PASSW
 * @property string $EMAIL
 * @property integer $LAST_LOGIN_TIME
 * @property string $ESTADO
 *
 * @property Perfil $pERFIL
 * @property Funcionario $fUNCIONARIO
 */
class User extends \yii\db\ActiveRecord implements IdentityInterface
{
    public $PASSWCONFIRMA,$PASSWATUAL;
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'user';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['ID', 'PERFIL_ID', 'FUNCIONARIO_ID', 'PASSWCONFIRMA', 'PASSWATUAL', 'USERNAME', 'EMAIL', 'LOGIN', 'PASSW', 'LAST_LOGIN_TIME', 'ESTADO'], 'required'],
            [['LAST_LOGIN_TIME', 'ID'], 'integer'],
            [['PERFIL_ID', 'FUNCIONARIO_ID'], 'string', 'max' => 36],
            [['USERNAME'], 'string', 'max' => 100],
            [['LOGIN'], 'string', 'max' => 50],
            [['PASSW'], 'string', 'max' => 64],
            [['EMAIL'], 'string', 'max' => 1000],
            [['EMAIL'], 'email'],
            [['ESTADO'], 'string', 'max' => 1],
            [['PASSWCONFIRMA'],'compare','compareAttribute'=>'PASSW','message'=>'Palavra-passe diferente da confirmação.'],
            [['PERFIL_ID'], 'exist', 'skipOnError' => true, 'targetClass' => Perfil::className(), 'targetAttribute' => ['PERFIL_ID' => 'ID']],
            [['FUNCIONARIO_ID'], 'exist', 'skipOnError' => true, 'targetClass' => Funcionario::className(), 'targetAttribute' => ['FUNCIONARIO_ID' => 'ID']],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'ID' => 'ID',
            'PERFIL_ID' => 'Perfil',
            'FUNCIONARIO_ID' => 'Funcionario  ID',
            'USERNAME' => 'Username',
            'PASSWATUAL' => 'Palavra-passe atual',
            'LOGIN' => 'Login',
            'PASSW' => 'Password',
            'PASSWCONFIRMA' => 'Confirmação da palavra-passe',
            'EMAIL' => 'Email',
            'LAST_LOGIN_TIME' => 'Last  Login  Time',
            'ESTADO' => 'Estado',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPERFIL()
    {
        return $this->hasOne(Perfil::className(), ['ID' => 'PERFIL_ID']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getFUNCIONARIO()
    {
        return $this->hasOne(Funcionario::className(), ['ID' => 'FUNCIONARIO_ID']);
    }
    
    public function validatePassword($password)
    {
        return $this->password === $password;
    }

    public function getAuthKey() {
        
    }

    public function getId() {
         return $this->getPrimaryKey();
    }

    public function validateAuthKey($authKey) {
        return $this->getAuthKey() === $authKey;
    }

    public static function findIdentity($id) {
        return static::findOne($id);
    }

    public static function findIdentityByAccessToken($token, $type = null) {
        return static::findOne(['access_token' => $token]);
    }
}
