<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\MenusSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = $idOperacao;
$this->params['breadcrumbs'][] = ['label' => $rootDesig, 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $this->title];
Yii::$app->session['acoes-menu']= $this->title;
?>
<div class="menus-index">
    
    <div class="row">
        <div class="col-md-12">
                <?php echo $this->render('_search', ['model' => $searchModel]); ?>
            <?php if($acaoCriar){?>
                <p class="pull-right">
                    <a class="btn btn-success btn-round" href="<?=Yii::$app->request->baseUrl?>/index.php?r=menus/create" 
                    id="myModal" data-toggle='modal' data-target="#modal" data-original-title='Criar Menus'>
                        <i class="fa fa-plus" style="margin-right:5px"></i>ADICIONAR
                    </a>
                </p>
            <?php }?>        
        </div>
    </div>

    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header card-header-rose card-header-icon">
                    <div class="card-icon">
                        <i class="material-icons">assignment</i>
                    </div>
                    <h4 class="card-title"><?= $this->title; ?></h4>
                </div>
                <div class="card-body">
                    <div class="table-responsive">
                        <?= GridView::widget([
                            'dataProvider' => $dataProvider,
                            'filterSelector' => 'select[name="per-page"]',
                            'tableOptions' => ['class'=>'table'],
                            'columns' => [
                                ['class' => 'yii\grid\SerialColumn'],
                                
                                'DS_MENU',
                                [
                                    'attribute'=>'SELF_ID','value'=>'sELF.DS_MENU'
                                ],
                                //'ORDEM',
                                //'URL:url',
                                // 'URL_ICON:url',
                                // 'ESTADO',
                                
                                ['class' => 'yii\grid\ActionColumn', 'template' => $acoes,
                                    'buttons' => [
                                        'delete' => function ($url, $model) {
                                            $options = array_merge([
                                                'data-original-title'=> Yii::t('app', 'Eliminar'),
                                                'aria-label' => Yii::t('yii', 'Eliminar'),
                                                'data-confirm' => Yii::t('yii', 'Pretendes eliminar "' . $model->DS_MENU . '?"'),
                                                'data-method' => 'post', 'data-pjax' => '0',
                                                'class' => 'btn btn-danger btn-link',
                                            ]);
                                            return Html::a('<i class="material-icons">close</i>', $url, $options);
                                        },
                                        'view' => function ($url, $model) {
                                            return Html::a('<i class="material-icons">person</i>',$url, [
                                            'id'=>'myModal','class'=>'btn btn-info btn-link','data-toggle'=>'modal', 
                                            'data-target'=>'#modal','data-original-title'=>Yii::t('app', 'Vista Detalhes')]);
                                        },
                                        'update' => function ($url, $model) {
                                            return Html::a('<i class="material-icons">edit</i>', $url, [
                                            'id'=>'myModal','class'=>'btn btn-success btn-link','data-toggle'=>'modal', 
                                            'data-target'=>'#modal','data-original-title'=>Yii::t('app', 'Editar')]);
                                        },
                                    ],
                                'header'=>'Operações','contentOptions'=>['class'=>'td-actions text-right','style'=>'width:100px']],
                            ],
                        ]); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
