<?php

use yii\helpers\Html;
use yii\helpers\Url;
use yii\grid\ActionColumn;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\TiketRegistrosSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Tiket Registros';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="tiket-registros-index">

<div class="row">
    <div class="col-md-12">
        <?php echo $this->render('_search', ['model' => $searchModel]); ?>
        <?php if($acaoCriar){?>
        <p class="pull-right">
            <a class="btn btn-success btn-round" href="<?=Yii::$app->request->baseUrl?>/index.php?r=tiket-registros/create" 
            id="myModal" data-toggle='modal' data-target="#modal" data-original-title='Criar Perfil'>
                <i class="fa fa-plus" style="margin-right:5px"></i>ADICIONAR
            </a>
        </p>
        <?php }?>        
    </div>
</div>
    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header card-header-rose card-header-icon">
                    <div class="card-icon">
                        <i class="material-icons">assignment</i>
                    </div>
                    <h4 class="card-title"><?= $this->title; ?></h4>
                         <a class="btn btn-success btn-round pull-right" href="<?=Yii::$app->request->baseUrl?>/index.php?r=tiket-registros/create" style="position: relative;margin-top: -35px;" id="myModal" data-toggle='modal' data-target="#modal" data-original-title='Criar Perfil'> <i class="fa fa-plus" style="margin-right:5px"></i>ADICIONAR
                        </a> 
                </div>
                <div class="card-body">
                    <div class="table-responsive"> 

                        <?= GridView::widget([
                            'dataProvider' => $dataProvider,
                            'filterSelector' => 'select[name="per-page"]',
                            'tableOptions' => ['class'=>'table'],
                            'columns' => [
                                ['class' => 'yii\grid\SerialColumn'],

                                        //'id',
                                        //'qrcod',
                                        'nome',
                                        'apelido',
                                        'pais',
                                        //'respondido',                                        
                                        //'local_partida',
                                        //'local_chegada',
                                        //'numero_doc',
                                        //'propal',
                                         'categoria',
                                         'solicta_destino',
                                        //'local',
                                        //'token',
                                        //'estado',
                                        //'data_registo',
                                       ['class' => 'yii\grid\ActionColumn', 'template' => '{view}{update}{imprimir-ticket}',
                                    'buttons' => [
                                       /* 'delete' => function ($url, $model) {
                                            $options = array_merge([
                                                'data-original-title'=> Yii::t('app', 'Eliminar'),
                                                'aria-label' => Yii::t('yii', 'Eliminar'),
                                                'data-confirm' => Yii::t('yii', 'Pretendes eliminar "' . $model->DS_MENU . '?"'),
                                                'data-method' => 'post', 'data-pjax' => '0',
                                                'class' => 'btn btn-danger btn-link',
                                            ]);
                                            return Html::a('<i class="material-icons">close</i>', $url, $options);
                                        },*/
                                        'view' => function ($url, $model) {
                                            return Html::a('<i class="material-icons">person</i>',$url, [
                                            'id'=>'myModal','class'=>'btn btn-info btn-link','data-toggle'=>'modal', 
                                            'data-target'=>'#modal','data-original-title'=>Yii::t('app', 'Vista Detalhes')]);
                                        },
                                        'update' => function ($url, $model) {
                                            return Html::a('<i class="material-icons">edit</i>', $url, [
                                            'id'=>'myModal','class'=>'btn btn-success btn-link','data-toggle'=>'modal', 
                                            'data-target'=>'#modal','data-original-title'=>Yii::t('app', 'Editar')]);
                                        },
                                         'imprimir-ticket' => function ($url, $model) {
                                            return Html::a('<i class="material-icons">print</i>', $url, [
                                            'id'=>'myModal','class'=>'btn btn-success btn-link','data-toggle'=>'modal', 
                                            'data-target'=>'#modal','data-original-title'=>Yii::t('app', 'Imprimir Ticket')]);
                                        },
                                        
                                    ],
                                'header'=>'Operações','contentOptions'=>['class'=>'td-actions text-right','style'=>'width:100px']
                                ],
                            ],
                        ]); ?>


                        </div>
                </div>
            </div>
        </div>
    </div>
</div>